Index: dll/shellext/shellbtrfs/contextmenu.cpp
===================================================================
--- dll/shellext/shellbtrfs/contextmenu.cpp	(révision 75772)
+++ dll/shellext/shellbtrfs/contextmenu.cpp	(copie de travail)
@@ -317,123 +498,739 @@
                     num++;
                 } while (fff != INVALID_HANDLE_VALUE);
             }
-            
+
             namelen = wcslen(&searchpath[pathend]) * sizeof(WCHAR);
-                        
+
             bcs = (btrfs_create_snapshot*)malloc(sizeof(btrfs_create_snapshot) - 1 + namelen);
+            bcs->readonly = FALSE;
+            bcs->posix = FALSE;
             bcs->subvol = h;
             bcs->namelen = namelen;
             memcpy(bcs->name, &searchpath[pathend], namelen);
-            
-            Status = NtFsControlFile(h2, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_CREATE_SNAPSHOT, NULL, 0, bcs, sizeof(btrfs_create_snapshot) - 1 + namelen);
-        
-            if (Status != STATUS_SUCCESS)
+
+            Status = NtFsControlFile(h2, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_CREATE_SNAPSHOT, bcs, sizeof(btrfs_create_snapshot) - 1 + namelen, NULL, 0);
+
+            if (!NT_SUCCESS(Status))
                 ShowNtStatusError(hwnd, Status);
-            
+
             CloseHandle(h2);
         }
-        
+
         CloseHandle(h);
     } else
         ShowError(hwnd, GetLastError());
 }
 
-HRESULT __stdcall BtrfsContextMenu::InvokeCommand(LPCMINVOKECOMMANDINFO pici) {
+static UINT64 __inline sector_align(UINT64 n, UINT64 a) {
+    if (n & (a - 1))
+        n = (n + a) & ~(a - 1);
+
+    return n;
+}
+
+BOOL BtrfsContextMenu::reflink_copy(HWND hwnd, const WCHAR* fn, const WCHAR* dir) {
+    HANDLE source, dest;
+    WCHAR* name, volpath1[255], volpath2[255];
+    std::wstring dirw, newpath;
+    BOOL ret = FALSE;
+    FILE_BASIC_INFO fbi;
+    FILETIME atime, mtime;
+    btrfs_inode_info bii;
+    btrfs_set_inode_info bsii;
+    ULONG bytesret;
+    NTSTATUS Status;
+    IO_STATUS_BLOCK iosb;
+    btrfs_set_xattr bsxa;
+
+    // Thanks to 0xbadfca11, whose version of reflink for Windows provided a few pointers on what
+    // to do here - https://github.com/0xbadfca11/reflink
+
+    name = PathFindFileNameW(fn);
+
+    dirw = dir;
+
+    if (dir[0] != 0 && dir[wcslen(dir) - 1] != '\\')
+        dirw += L"\\";
+
+    newpath = dirw;
+    newpath += name;
+
+    if (!get_volume_path_parent(fn, volpath1, sizeof(volpath1) / sizeof(WCHAR))) {
+        ShowError(hwnd, GetLastError());
+        return FALSE;
+    }
+
+    if (!GetVolumePathNameW(dir, volpath2, sizeof(volpath2) / sizeof(WCHAR))) {
+        ShowError(hwnd, GetLastError());
+        return FALSE;
+    }
+
+    if (wcscmp(volpath1, volpath2)) // different filesystems
+        return FALSE;
+
+    source = CreateFileW(fn, GENERIC_READ | FILE_TRAVERSE, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS | FILE_OPEN_REPARSE_POINT, NULL);
+    if (source == INVALID_HANDLE_VALUE) {
+        ShowError(hwnd, GetLastError());
+        return FALSE;
+    }
+
+    Status = NtFsControlFile(source, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_GET_INODE_INFO, NULL, 0, &bii, sizeof(btrfs_inode_info));
+    if (!NT_SUCCESS(Status)) {
+        ShowNtStatusError(hwnd, Status);
+        CloseHandle(source);
+        return FALSE;
+    }
+
+    // if subvol, do snapshot instead
+    if (bii.inode == SUBVOL_ROOT_INODE) {
+        btrfs_create_snapshot* bcs;
+        HANDLE dirh, fff;
+        std::wstring destname, search;
+        WIN32_FIND_DATAW wfd;
+        int num = 2;
+
+        dirh = CreateFileW(dir, FILE_ADD_SUBDIRECTORY, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);
+        if (dirh == INVALID_HANDLE_VALUE) {
+            ShowError(hwnd, GetLastError());
+            CloseHandle(source);
+            return FALSE;
+        }
+
+        search = dirw;
+        search += name;
+        destname = name;
+
+        fff = FindFirstFileW(search.c_str(), &wfd);
+
+        if (fff != INVALID_HANDLE_VALUE) {
+            do {
+                std::wstringstream ss;
+
+                FindClose(fff);
+
+                ss << name;
+                ss << L" (";
+                ss << num;
+                ss << L")";
+                destname = ss.str();
+
+                search = dirw + destname;
+
+                fff = FindFirstFileW(search.c_str(), &wfd);
+                num++;
+            } while (fff != INVALID_HANDLE_VALUE);
+        }
+
+        bcs = (btrfs_create_snapshot*)malloc(sizeof(btrfs_create_snapshot) - sizeof(WCHAR) + (destname.length() * sizeof(WCHAR)));
+        bcs->subvol = source;
+        bcs->namelen = destname.length() * sizeof(WCHAR);
+        memcpy(bcs->name, destname.c_str(), destname.length() * sizeof(WCHAR));
+
+        Status = NtFsControlFile(dirh, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_CREATE_SNAPSHOT, bcs, sizeof(btrfs_create_snapshot) - sizeof(WCHAR) + bcs->namelen, NULL, 0);
+
+        free(bcs);
+
+        if (!NT_SUCCESS(Status)) {
+            ShowNtStatusError(hwnd, Status);
+            CloseHandle(source);
+            CloseHandle(dirh);
+            return FALSE;
+        }
+
+        CloseHandle(source);
+        CloseHandle(dirh);
+        return TRUE;
+    }
+
+    if (!GetFileInformationByHandleEx(source, FileBasicInfo, &fbi, sizeof(FILE_BASIC_INFO))) {
+        ShowError(hwnd, GetLastError());
+        CloseHandle(source);
+        return FALSE;
+    }
+
+    if (bii.type == BTRFS_TYPE_CHARDEV || bii.type == BTRFS_TYPE_BLOCKDEV || bii.type == BTRFS_TYPE_FIFO || bii.type == BTRFS_TYPE_SOCKET) {
+        HANDLE dirh;
+        ULONG bmnsize;
+        btrfs_mknod* bmn;
+
+        dirh = CreateFileW(dir, FILE_ADD_FILE, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);
+        if (dirh == INVALID_HANDLE_VALUE) {
+            ShowError(hwnd, GetLastError());
+            CloseHandle(source);
+            return FALSE;
+        }
+
+        bmnsize = offsetof(btrfs_mknod, name[0]) + (wcslen(name) * sizeof(WCHAR));
+        bmn = (btrfs_mknod*)malloc(bmnsize);
+
+        bmn->inode = 0;
+        bmn->type = bii.type;
+        bmn->st_rdev = bii.st_rdev;
+        bmn->namelen = wcslen(name) * sizeof(WCHAR);
+        memcpy(bmn->name, name, bmn->namelen);
+
+        Status = NtFsControlFile(dirh, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_MKNOD, bmn, bmnsize, NULL, 0);
+        if (!NT_SUCCESS(Status)) {
+            ShowNtStatusError(hwnd, Status);
+            CloseHandle(dirh);
+            CloseHandle(source);
+            free(bmn);
+            return FALSE;
+        }
+
+        CloseHandle(dirh);
+        free(bmn);
+
+        dest = CreateFileW(newpath.c_str(), GENERIC_READ | GENERIC_WRITE | DELETE, 0, NULL, OPEN_EXISTING, 0, NULL);
+    } else if (fbi.FileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
+        if (CreateDirectoryExW(fn, newpath.c_str(), NULL))
+            dest = CreateFileW(newpath.c_str(), GENERIC_READ | GENERIC_WRITE | DELETE, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE,
+                               NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);
+        else
+            dest = INVALID_HANDLE_VALUE;
+    } else
+        dest = CreateFileW(newpath.c_str(), GENERIC_READ | GENERIC_WRITE | DELETE, 0, NULL, CREATE_NEW, 0, source);
+
+    if (dest == INVALID_HANDLE_VALUE) {
+        int num = 2;
+
+        if (GetLastError() != ERROR_FILE_EXISTS && GetLastError() != ERROR_ALREADY_EXISTS && wcscmp(fn, newpath.c_str())) {
+            ShowError(hwnd, GetLastError());
+            CloseHandle(source);
+            return FALSE;
+        }
+
+        do {
+            WCHAR* ext;
+            std::wstringstream ss;
+
+            ext = PathFindExtensionW(fn);
+
+            ss << dirw;
+
+            if (*ext == 0) {
+                ss << name;
+                ss << L" (";
+                ss << num;
+                ss << L")";
+            } else {
+                std::wstring namew = name;
+
+                ss << namew.substr(0, ext - name);
+                ss << L" (";
+                ss << num;
+                ss << L")";
+                ss << ext;
+            }
+
+            newpath = ss.str();
+            if (fbi.FileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
+                if (CreateDirectoryExW(fn, newpath.c_str(), NULL))
+                    dest = CreateFileW(newpath.c_str(), GENERIC_READ | GENERIC_WRITE | DELETE, 0, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);
+                else
+                    dest = INVALID_HANDLE_VALUE;
+            } else
+                dest = CreateFileW(newpath.c_str(), GENERIC_READ | GENERIC_WRITE | DELETE, 0, NULL, CREATE_NEW, 0, source);
+
+            if (dest == INVALID_HANDLE_VALUE) {
+                if (GetLastError() != ERROR_FILE_EXISTS && GetLastError() != ERROR_ALREADY_EXISTS) {
+                    ShowError(hwnd, GetLastError());
+                    CloseHandle(source);
+                    return FALSE;
+                }
+
+                num++;
+            } else
+                break;
+        } while (TRUE);
+    }
+
+    memset(&bsii, 0, sizeof(btrfs_set_inode_info));
+
+    bsii.flags_changed = TRUE;
+    bsii.flags = bii.flags;
+
+    if (bii.flags & BTRFS_INODE_COMPRESS) {
+        bsii.compression_type_changed = TRUE;
+        bsii.compression_type = bii.compression_type;
+    }
+
+    Status = NtFsControlFile(dest, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_SET_INODE_INFO, &bsii, sizeof(btrfs_set_inode_info), NULL, 0);
+    if (!NT_SUCCESS(Status)) {
+        ShowNtStatusError(hwnd, Status);
+        goto end;
+    }
+
+    if (fbi.FileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
+        if (!(fbi.FileAttributes & FILE_ATTRIBUTE_REPARSE_POINT)) {
+            HANDLE h;
+            WIN32_FIND_DATAW fff;
+            std::wstring qs;
+
+            qs = fn;
+            qs += L"\\*";
+
+            h = FindFirstFileW(qs.c_str(), &fff);
+            if (h != INVALID_HANDLE_VALUE) {
+                do {
+                    std::wstring fn2;
+
+                    if (fff.cFileName[0] == '.' && (fff.cFileName[1] == 0 || (fff.cFileName[1] == '.' && fff.cFileName[2] == 0)))
+                        continue;
+
+                    fn2 = fn;
+                    fn2 += L"\\";
+                    fn2 += fff.cFileName;
+
+                    if (!reflink_copy(hwnd, fn2.c_str(), newpath.c_str()))
+                        goto end;
+                } while (FindNextFileW(h, &fff));
+
+                FindClose(h);
+            }
+        }
+
+        // CreateDirectoryExW also copies streams, no need to do it here
+    } else {
+        HANDLE h;
+        WIN32_FIND_STREAM_DATA fsd;
+
+        if (fbi.FileAttributes & FILE_ATTRIBUTE_REPARSE_POINT) {
+            reparse_header rh;
+            ULONG rplen;
+            UINT8* rp;
+
+            if (!DeviceIoControl(source, FSCTL_GET_REPARSE_POINT, NULL, 0, &rh, sizeof(reparse_header), &bytesret, NULL)) {
+                if (GetLastError() != ERROR_MORE_DATA) {
+                    ShowError(hwnd, GetLastError());
+                    goto end;
+                }
+            }
+
+            rplen = sizeof(reparse_header) + rh.ReparseDataLength;
+            rp = (UINT8*)malloc(rplen);
+
+            if (!DeviceIoControl(source, FSCTL_GET_REPARSE_POINT, NULL, 0, rp, rplen, &bytesret, NULL)) {
+                ShowError(hwnd, GetLastError());
+                goto end;
+            }
+
+            if (!DeviceIoControl(dest, FSCTL_SET_REPARSE_POINT, rp, rplen, NULL, 0, &bytesret, NULL)) {
+                ShowError(hwnd, GetLastError());
+                goto end;
+            }
+
+            free(rp);
+        } else {
+            FILE_STANDARD_INFO fsi;
+            FILE_END_OF_FILE_INFO feofi;
+            FSCTL_GET_INTEGRITY_INFORMATION_BUFFER fgiib;
+            FSCTL_SET_INTEGRITY_INFORMATION_BUFFER fsiib;
+            DUPLICATE_EXTENTS_DATA ded;
+            UINT64 offset, alloc_size;
+            ULONG maxdup;
+
+            if (!GetFileInformationByHandleEx(source, FileStandardInfo, &fsi, sizeof(FILE_STANDARD_INFO))) {
+                ShowError(hwnd, GetLastError());
+                goto end;
+            }
+
+            if (!DeviceIoControl(source, FSCTL_GET_INTEGRITY_INFORMATION, NULL, 0, &fgiib, sizeof(FSCTL_GET_INTEGRITY_INFORMATION_BUFFER), &bytesret, NULL)) {
+                ShowError(hwnd, GetLastError());
+                goto end;
+            }
+
+            if (fbi.FileAttributes & FILE_ATTRIBUTE_SPARSE_FILE) {
+                if (!DeviceIoControl(dest, FSCTL_SET_SPARSE, NULL, 0, NULL, 0, &bytesret, NULL)) {
+                    ShowError(hwnd, GetLastError());
+                    goto end;
+                }
+            }
+
+            fsiib.ChecksumAlgorithm = fgiib.ChecksumAlgorithm;
+            fsiib.Reserved = 0;
+            fsiib.Flags = fgiib.Flags;
+            if (!DeviceIoControl(dest, FSCTL_SET_INTEGRITY_INFORMATION, &fsiib, sizeof(FSCTL_SET_INTEGRITY_INFORMATION_BUFFER), NULL, 0, &bytesret, NULL)) {
+                ShowError(hwnd, GetLastError());
+                goto end;
+            }
+
+            feofi.EndOfFile = fsi.EndOfFile;
+            if (!SetFileInformationByHandle(dest, FileEndOfFileInfo, &feofi, sizeof(FILE_END_OF_FILE_INFO))){
+                ShowError(hwnd, GetLastError());
+                goto end;
+            }
+
+            ded.FileHandle = source;
+            maxdup = 0xffffffff - fgiib.ClusterSizeInBytes + 1;
+
+            alloc_size = sector_align(fsi.EndOfFile.QuadPart, fgiib.ClusterSizeInBytes);
+
+            offset = 0;
+            while (offset < alloc_size) {
+                ded.SourceFileOffset.QuadPart = ded.TargetFileOffset.QuadPart = offset;
+                ded.ByteCount.QuadPart = maxdup < (alloc_size - offset) ? maxdup : (alloc_size - offset);
+                if (!DeviceIoControl(dest, FSCTL_DUPLICATE_EXTENTS_TO_FILE, &ded, sizeof(DUPLICATE_EXTENTS_DATA), NULL, 0, &bytesret, NULL)) {
+                    ShowError(hwnd, GetLastError());
+                    goto end;
+                }
+
+                offset += ded.ByteCount.QuadPart;
+            }
+        }
+
+        h = FindFirstStreamW(fn, FindStreamInfoStandard, &fsd, 0);
+        if (h != INVALID_HANDLE_VALUE) {
+            do {
+                std::wstring sn;
+
+                sn = fsd.cStreamName;
+
+                if (sn != L"::$DATA" && sn.length() > 6 && sn.substr(sn.length() - 6, 6) == L":$DATA") {
+                    HANDLE stream;
+                    UINT8* data = NULL;
+
+                    if (fsd.StreamSize.QuadPart > 0) {
+                        std::wstring fn2;
+
+                        fn2 = fn;
+                        fn2 += sn;
+
+                        stream = CreateFileW(fn2.c_str(), GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
+
+                        if (stream == INVALID_HANDLE_VALUE) {
+                            ShowError(hwnd, GetLastError());
+                            goto end;
+                        }
+
+                        // We can get away with this because our streams are guaranteed to be below 64 KB -
+                        // don't do this on NTFS!
+                        data = (UINT8*)malloc(fsd.StreamSize.QuadPart);
+
+                        if (!ReadFile(stream, data, fsd.StreamSize.QuadPart, &bytesret, NULL)) {
+                            ShowError(hwnd, GetLastError());
+                            free(data);
+                            CloseHandle(stream);
+                            goto end;
+                        }
+
+                        CloseHandle(stream);
+                    }
+
+                    stream = CreateFileW((newpath + sn).c_str(), GENERIC_READ | GENERIC_WRITE | DELETE, 0, NULL, CREATE_NEW, 0, NULL);
+
+                    if (stream == INVALID_HANDLE_VALUE) {
+                        ShowError(hwnd, GetLastError());
+
+                        if (data) free(data);
+
+                        goto end;
+                    }
+
+                    if (data) {
+                        if (!WriteFile(stream, data, fsd.StreamSize.QuadPart, &bytesret, NULL)) {
+                            ShowError(hwnd, GetLastError());
+                            free(data);
+                            CloseHandle(stream);
+                            goto end;
+                        }
+
+                        free(data);
+                    }
+
+                    CloseHandle(stream);
+                }
+            } while (FindNextStreamW(h, &fsd));
+
+            FindClose(h);
+        }
+    }
+
+    atime.dwLowDateTime = fbi.LastAccessTime.LowPart;
+    atime.dwHighDateTime = fbi.LastAccessTime.HighPart;
+    mtime.dwLowDateTime = fbi.LastWriteTime.LowPart;
+    mtime.dwHighDateTime = fbi.LastWriteTime.HighPart;
+    SetFileTime(dest, NULL, &atime, &mtime);
+
+    Status = NtFsControlFile(source, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_GET_XATTRS, NULL, 0, &bsxa, sizeof(btrfs_set_xattr));
+
+    if (Status == STATUS_BUFFER_OVERFLOW || (NT_SUCCESS(Status) && bsxa.valuelen > 0)) {
+        ULONG xalen = 0;
+        btrfs_set_xattr *xa = NULL, *xa2;
+
+        do {
+            xalen += 1024;
+
+            if (xa) free(xa);
+            xa = (btrfs_set_xattr*)malloc(xalen);
+
+            Status = NtFsControlFile(source, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_GET_XATTRS, NULL, 0, xa, xalen);
+        } while (Status == STATUS_BUFFER_OVERFLOW);
+
+        if (!NT_SUCCESS(Status)) {
+            free(xa);
+            ShowNtStatusError(hwnd, Status);
+            goto end;
+        }
+
+        xa2 = xa;
+        while (xa2->valuelen > 0) {
+            Status = NtFsControlFile(dest, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_SET_XATTR, xa2,
+                                     offsetof(btrfs_set_xattr, data[0]) + xa2->namelen + xa2->valuelen, NULL, 0);
+            if (!NT_SUCCESS(Status)) {
+                free(xa);
+                ShowNtStatusError(hwnd, Status);
+                goto end;
+            }
+            xa2 = (btrfs_set_xattr*)&xa2->data[xa2->namelen + xa2->valuelen];
+        }
+
+        free(xa);
+    } else if (!NT_SUCCESS(Status)) {
+        ShowNtStatusError(hwnd, Status);
+        goto end;
+    }
+
+    ret = TRUE;
+
+end:
+    if (!ret) {
+        FILE_DISPOSITION_INFO fdi;
+
+        fdi.DeleteFile = TRUE;
+        if (!SetFileInformationByHandle(dest, FileDispositionInfo, &fdi, sizeof(FILE_DISPOSITION_INFO)))
+            ShowError(hwnd, GetLastError());
+    }
+
+    CloseHandle(dest);
+    CloseHandle(source);
+
+    return ret;
+}
+
+HRESULT __stdcall BtrfsContextMenu::InvokeCommand(LPCMINVOKECOMMANDINFO picia) {
+    LPCMINVOKECOMMANDINFOEX pici = (LPCMINVOKECOMMANDINFOEX)picia;
+
     if (ignore)
         return E_INVALIDARG;
-    
+
     if (!bg) {
-        if ((IS_INTRESOURCE(pici->lpVerb) && pici->lpVerb == 0) || !strcmp(pici->lpVerb, SNAPSHOT_VERBA)) {
+        if ((IS_INTRESOURCE(pici->lpVerb) && allow_snapshot && pici->lpVerb == 0) || (!IS_INTRESOURCE(pici->lpVerb) && !strcmp(pici->lpVerb, SNAPSHOT_VERBA))) {
             UINT num_files, i;
             WCHAR fn[MAX_PATH];
-            
+
             if (!stgm_set)
                 return E_FAIL;
-            
+
             num_files = DragQueryFileW((HDROP)stgm.hGlobal, 0xFFFFFFFF, NULL, 0);
-            
+
             if (num_files == 0)
                 return E_FAIL;
-            
+
             for (i = 0; i < num_files; i++) {
-                if (DragQueryFileW((HDROP)stgm.hGlobal, i, fn, sizeof(fn) / sizeof(MAX_PATH))) {
+                if (DragQueryFileW((HDROP)stgm.hGlobal, i, fn, sizeof(fn) / sizeof(WCHAR))) {
                     create_snapshot(pici->hwnd, fn);
                 }
             }
 
             return S_OK;
-        }
-        
-        return E_FAIL;
-    }
-    
-    if ((IS_INTRESOURCE(pici->lpVerb) && pici->lpVerb == 0) || !strcmp(pici->lpVerb, NEW_SUBVOL_VERBA)) {
-        HANDLE h;
-        IO_STATUS_BLOCK iosb;
-        NTSTATUS Status;
-        ULONG pathlen, searchpathlen, pathend;
-        WCHAR name[MAX_PATH], *searchpath;
-        HANDLE fff;
-        WIN32_FIND_DATAW wfd;
-        
-        if (!LoadStringW(module, IDS_NEW_SUBVOL_FILENAME, name, MAX_PATH)) {
-            ShowError(pici->hwnd, GetLastError());
-            return E_FAIL;
-        }
-        
-        h = CreateFileW(path, FILE_ADD_SUBDIRECTORY, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);
-    
-        if (h == INVALID_HANDLE_VALUE) {
-            ShowError(pici->hwnd, GetLastError());
-            return E_FAIL;
-        }
-        
-        pathlen = wcslen(path);
-        
-        searchpathlen = pathlen + wcslen(name) + 10;
-        searchpath = (WCHAR*)malloc(searchpathlen * sizeof(WCHAR));
-        
-        StringCchCopyW(searchpath, searchpathlen, path);
-        StringCchCatW(searchpath, searchpathlen, L"\\");
-        pathend = wcslen(searchpath);
-        
-        StringCchCatW(searchpath, searchpathlen, name);
-        
-        fff = FindFirstFileW(searchpath, &wfd);
-        
-        if (fff != INVALID_HANDLE_VALUE) {
-            ULONG i = wcslen(searchpath), num = 2;
-            
-            do {
-                FindClose(fff);
-                
-                searchpath[i] = 0;
-                if (StringCchPrintfW(searchpath, searchpathlen, L"%s (%u)", searchpath, num) == STRSAFE_E_INSUFFICIENT_BUFFER) {
-                    MessageBoxW(pici->hwnd, L"Filename too long.\n", L"Error", MB_ICONERROR);
-                    CloseHandle(h);
-                    return E_FAIL;
+        } else if ((IS_INTRESOURCE(pici->lpVerb) && ((allow_snapshot && (ULONG_PTR)pici->lpVerb == 1) || (!allow_snapshot && (ULONG_PTR)pici->lpVerb == 0))) ||
+                   (!IS_INTRESOURCE(pici->lpVerb) && !strcmp(pici->lpVerb, SEND_VERBA))) {
+            UINT num_files, i;
+            WCHAR dll[MAX_PATH], fn[MAX_PATH];
+            std::wstring t;
+            SHELLEXECUTEINFOW sei;
+
+            GetModuleFileNameW(module, dll, sizeof(dll) / sizeof(WCHAR));
+
+            if (!stgm_set)
+                return E_FAIL;
+
+            num_files = DragQueryFileW((HDROP)stgm.hGlobal, 0xFFFFFFFF, NULL, 0);
+
+            if (num_files == 0)
+                return E_FAIL;
+
+            for (i = 0; i < num_files; i++) {
+                if (DragQueryFileW((HDROP)stgm.hGlobal, i, fn, sizeof(fn) / sizeof(WCHAR))) {
+                    t = L"\"";
+                    t += dll;
+                    t += L"\",SendSubvolGUI ";
+                    t += fn;
+
+                    RtlZeroMemory(&sei, sizeof(sei));
+
+                    sei.cbSize = sizeof(sei);
+                    sei.hwnd = pici->hwnd;
+                    sei.lpVerb = L"runas";
+                    sei.lpFile = L"rundll32.exe";
+                    sei.lpParameters = t.c_str();
+                    sei.nShow = SW_SHOW;
+                    sei.fMask = SEE_MASK_NOCLOSEPROCESS;
+
+                    if (!ShellExecuteExW(&sei)) {
+                        ShowError(pici->hwnd, GetLastError());
+                        return E_FAIL;
+                    }
+
+                    WaitForSingleObject(sei.hProcess, INFINITE);
+                    CloseHandle(sei.hProcess);
                 }
+            }
 
-                fff = FindFirstFileW(searchpath, &wfd);
-                num++;
-            } while (fff != INVALID_HANDLE_VALUE);
+            return S_OK;
         }
-        
-        Status = NtFsControlFile(h, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_CREATE_SUBVOL, NULL, 0, &searchpath[pathend], wcslen(&searchpath[pathend]) * sizeof(WCHAR));
-        
-        free(searchpath);
-        
-        if (Status != STATUS_SUCCESS) {
+    } else {
+        if ((IS_INTRESOURCE(pici->lpVerb) && (ULONG_PTR)pici->lpVerb == 0) || (!IS_INTRESOURCE(pici->lpVerb) && !strcmp(pici->lpVerb, NEW_SUBVOL_VERBA))) {
+            HANDLE h;
+            IO_STATUS_BLOCK iosb;
+            NTSTATUS Status;
+            ULONG pathlen, searchpathlen, pathend, bcslen;
+            WCHAR name[MAX_PATH], *searchpath;
+            btrfs_create_subvol* bcs;
+            HANDLE fff;
+            WIN32_FIND_DATAW wfd;
+
+            if (!LoadStringW(module, IDS_NEW_SUBVOL_FILENAME, name, MAX_PATH)) {
+                ShowError(pici->hwnd, GetLastError());
+                return E_FAIL;
+            }
+
+            h = CreateFileW(path, FILE_ADD_SUBDIRECTORY, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);
+
+            if (h == INVALID_HANDLE_VALUE) {
+                ShowError(pici->hwnd, GetLastError());
+                return E_FAIL;
+            }
+
+            pathlen = wcslen(path);
+
+            searchpathlen = pathlen + wcslen(name) + 10;
+            searchpath = (WCHAR*)malloc(searchpathlen * sizeof(WCHAR));
+
+            StringCchCopyW(searchpath, searchpathlen, path);
+            StringCchCatW(searchpath, searchpathlen, L"\\");
+            pathend = wcslen(searchpath);
+
+            StringCchCatW(searchpath, searchpathlen, name);
+
+            fff = FindFirstFileW(searchpath, &wfd);
+
+            if (fff != INVALID_HANDLE_VALUE) {
+                ULONG i = wcslen(searchpath), num = 2;
+
+                do {
+                    FindClose(fff);
+
+                    searchpath[i] = 0;
+                    if (StringCchPrintfW(searchpath, searchpathlen, L"%s (%u)", searchpath, num) == STRSAFE_E_INSUFFICIENT_BUFFER) {
+                        MessageBoxW(pici->hwnd, L"Filename too long.\n", L"Error", MB_ICONERROR);
+                        CloseHandle(h);
+                        return E_FAIL;
+                    }
+
+                    fff = FindFirstFileW(searchpath, &wfd);
+                    num++;
+                } while (fff != INVALID_HANDLE_VALUE);
+            }
+
+            bcslen = offsetof(btrfs_create_subvol, name[0]) + (wcslen(&searchpath[pathend]) * sizeof(WCHAR));
+            bcs = (btrfs_create_subvol*)malloc(bcslen);
+
+            bcs->readonly = FALSE;
+            bcs->posix = FALSE;
+            bcs->namelen = wcslen(&searchpath[pathend]) * sizeof(WCHAR);
+            memcpy(bcs->name, &searchpath[pathend], bcs->namelen);
+
+            Status = NtFsControlFile(h, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_CREATE_SUBVOL, bcs, bcslen, NULL, 0);
+
+            free(searchpath);
+            free(bcs);
+
+            if (!NT_SUCCESS(Status)) {
+                CloseHandle(h);
+                ShowNtStatusError(pici->hwnd, Status);
+                return E_FAIL;
+            }
+
             CloseHandle(h);
-            ShowNtStatusError(pici->hwnd, Status);
-            return E_FAIL;
+
+            return S_OK;
+        } else if ((IS_INTRESOURCE(pici->lpVerb) && (ULONG_PTR)pici->lpVerb == 1) || (!IS_INTRESOURCE(pici->lpVerb) && !strcmp(pici->lpVerb, RECV_VERBA))) {
+            WCHAR dll[MAX_PATH];
+            std::wstring t;
+            SHELLEXECUTEINFOW sei;
+
+            GetModuleFileNameW(module, dll, sizeof(dll) / sizeof(WCHAR));
+
+            t = L"\"";
+            t += dll;
+            t += L"\",RecvSubvolGUI ";
+            t += path;
+
+            RtlZeroMemory(&sei, sizeof(sei));
+
+            sei.cbSize = sizeof(sei);
+            sei.hwnd = pici->hwnd;
+            sei.lpVerb = L"runas";
+            sei.lpFile = L"rundll32.exe";
+            sei.lpParameters = t.c_str();
+            sei.nShow = SW_SHOW;
+            sei.fMask = SEE_MASK_NOCLOSEPROCESS;
+
+            if (!ShellExecuteExW(&sei)) {
+                ShowError(pici->hwnd, GetLastError());
+                return E_FAIL;
+            }
+
+            WaitForSingleObject(sei.hProcess, INFINITE);
+            CloseHandle(sei.hProcess);
+
+            return S_OK;
+        } else if ((IS_INTRESOURCE(pici->lpVerb) && (ULONG_PTR)pici->lpVerb == 2) || (!IS_INTRESOURCE(pici->lpVerb) && !strcmp(pici->lpVerb, REFLINK_VERBA))) {
+            HDROP hdrop;
+
+            if (!IsClipboardFormatAvailable(CF_HDROP))
+                return S_OK;
+
+            if (!OpenClipboard(pici->hwnd)) {
+                ShowError(pici->hwnd, GetLastError());
+                return E_FAIL;
+            }
+
+            hdrop = (HDROP)GetClipboardData(CF_HDROP);
+
+            if (hdrop) {
+                HANDLE lh;
+
+                lh = GlobalLock(hdrop);
+
+                if (lh) {
+                    ULONG num_files, i;
+                    WCHAR fn[MAX_PATH];
+
+                    num_files = DragQueryFileW(hdrop, 0xFFFFFFFF, NULL, 0);
+
+                    for (i = 0; i < num_files; i++) {
+                        if (DragQueryFileW(hdrop, i, fn, sizeof(fn) / sizeof(WCHAR))) {
+                            if (!reflink_copy(pici->hwnd, fn, pici->lpDirectoryW)) {
+                                GlobalUnlock(lh);
+                                CloseClipboard();
+                                return E_FAIL;
+                            }
+                        }
+                    }
+
+                    GlobalUnlock(lh);
+                }
+            }
+
+            CloseClipboard();
+
+            return S_OK;
         }
-        
-        CloseHandle(h);
-        
-        return S_OK;
     }
-    
+
     return E_FAIL;
 }
 
